#include "xtrack.h"

SAT *Create_Sat(SAT *sat)
{
  SAT *satnw;
  satnw=calloc(1,sizeof(SAT));
  if (sat)
  {
    while (sat->next) sat=sat->next;
    sat->next=satnw;
    satnw->prev=sat;
  }
  return satnw;
}

int Remove_Sat(SAT *sat)
{
  if (!sat) return 0;
  if (sat==sat->db->sat_sel) sat->db->sat_sel=NULL;
  if (sat->prev) sat->prev->next=sat->next;
  if (sat->next) sat->next->prev=sat->prev;
  if (sat->db->sat==sat) sat->db->sat=sat->next;
  free(sat);
  return 1;
}

SAT *Find_Sat(SAT *sat,char *satname)
{
  for (; sat; sat=sat->next)
    if (!strcmp(sat->satname,satname))
      return sat;
  return NULL;
}

int add_to_db(DBASE *db,SAT *sat,gboolean on)
{
  SAT *sat_new,*sat_old;
  if (!sat) return 0;
  while (sat->prev) sat=sat->prev;
#ifdef OUD
  if (!db->sat_sel) db->sat_sel=sat;
  if (!db->sat) db->sat=sat;
  for (; sat; sat=sat->next) sat->db=db;
#else
  db->sat_sel=NULL;
  for (sat_new=sat; sat_new; sat_new=sat_new->next)
  {
    if ((sat_old=Find_Sat(db->sat,sat_new->satname)))
    {
      sat_new->visible=sat_old->visible;
      sat_new->selected=sat_old->selected;
      if (sat_new->selected) db->sat_sel=sat_new;
    }
    if (on) sat_new->visible=TRUE;
    sat_new->db=db;
  }
  while (Remove_Sat(db->sat));
  db->sat=sat;
  if (!db->sat_sel)
  {
    db->sat_sel=db->sat;
    db->sat->selected=TRUE;
  }
#endif
  return 1;
}

SAT *find_sat(SAT *sat,char *name)
{
  for (; sat; sat=sat->next)
  {
    if ((sat->satname) && (!strcmp(sat->satname,name))) break;
  }
  return sat;
}
